#!/usr/bin/php -q
<?php

require_once '/usr/local/opmon/etc/config.php';
require_once '/usr/local/opmon/libexec/php-nagios-plugins/Nagios_Plugin.php';

/*
FORTINET-FORTIAUTHENTICATOR-MIB::facSysModel.0 = STRING: FAC200D
FORTINET-FORTIAUTHENTICATOR-MIB::facSysSerial.0 = STRING: FAC2HD3A15000049
FORTINET-FORTIAUTHENTICATOR-MIB::facSysVersion.0 = STRING: v4.00-build0008
FORTINET-FORTIAUTHENTICATOR-MIB::facSysCpuUsage.0 = Gauge32: 8
Instantaneous CPU usage
FORTINET-FORTIAUTHENTICATOR-MIB::facSysMemUsage.0 = Gauge32: 20
Instantaneous memory utilization
FORTINET-FORTIAUTHENTICATOR-MIB::facSysLogDiskUsage.0 = Gauge32: 0
Instantaneous log disk usage
FORTINET-FORTIAUTHENTICATOR-MIB::facHaCurrentStatus.0 = INTEGER: clusterMaster(2)
Instantaneous HA status for this node
	unknownOrDetermining (1),
	clusterMaster (2),
	clusterSlave (3),
	standaloneMaster (4),
	loadBalancingSlave (5),
	disabled (255)
FORTINET-FORTIAUTHENTICATOR-MIB::facAuthUserCount.0 = INTEGER: 105
Number of local users
FORTINET-FORTIAUTHENTICATOR-MIB::facAuthGroupCount.0 = INTEGER: 1
Number of user groups
FORTINET-FORTIAUTHENTICATOR-MIB::facFortiTokenCount.0 = INTEGER: 152
Number of FortiTokens
FORTINET-FORTIAUTHENTICATOR-MIB::facAuthUsersRemaining.0 = INTEGER: 395
Number of local users that can still be added before reaching the table limit
FORTINET-FORTIAUTHENTICATOR-MIB::facAuthGroupRemaining.0 = INTEGER: 49
Number of user groups that can still be added before reaching the table limit
FORTINET-FORTIAUTHENTICATOR-MIB::facFortiTokenRemaining.0 = INTEGER: 848
Number of FortiTokens that can still be added before reaching the table limit
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusNasCount.0 = INTEGER: 2
Number of Radius NAS
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusNasRemaining.0 = INTEGER: 48
Number of Radius NAS that can still be added before reaching the table limit
FORTINET-FORTIAUTHENTICATOR-MIB::facUserCertificateCount.0 = INTEGER: 0
Number of user certificates
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusLoginsTotal.0 = INTEGER: 264
Number of Radius logins since startup
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusLogins5Mins.0 = INTEGER: 1
Number of Radius logins in the last 5 minutes
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusFailuresTotal.0 = INTEGER: 489
Number of Radius login failures since startup
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusFailures5Mins.0 = INTEGER: 0
Number of Radius login failures in the last 5 minutes
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusAccountingTotal.0 = INTEGER: 0
Number of Radius accounting records since startup
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusAccounting5Mins.0 = INTEGER: 0
Number of Radius accounting records in the last 5 minutes
FORTINET-FORTIAUTHENTICATOR-MIB::facLdapLoginsTotal.0 = INTEGER: 0
Number of Ldap logins since startup
FORTINET-FORTIAUTHENTICATOR-MIB::facLdapLogins5Mins.0 = INTEGER: 0
Number of Ldap logins in the last 5 minutes
FORTINET-FORTIAUTHENTICATOR-MIB::facLdapFailuresTotal.0 = INTEGER: 3
Number of Ldap login failures since startup
FORTINET-FORTIAUTHENTICATOR-MIB::facLdapFailures5Mins.0 = INTEGER: 0
Number of Ldap login failures in the last 5 minutes
FORTINET-FORTIAUTHENTICATOR-MIB::facAuthEventsTotal.0 = INTEGER: 756
Number of authentication events since startup
FORTINET-FORTIAUTHENTICATOR-MIB::facAuthEvents5Mins.0 = INTEGER: 1
Number of authentication events in the last 5 minutes
FORTINET-FORTIAUTHENTICATOR-MIB::facAuthFailuresTotal.0 = INTEGER: 492
Number of authentication failures since startup
FORTINET-FORTIAUTHENTICATOR-MIB::facAuthFailures5Mins.0 = INTEGER: 0
Number of authentication failures in the last 5 minutes
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusProxyInTotal.0 = INTEGER: 0
Number of Radius accounting proxy requests received since startup
FORTINET-FORTIAUTHENTICATOR-MIB::facRadiusProxyOutTotal.0 = INTEGER: 0
Number of Radius accounting proxy requests sent since startup
*/

define("VERSION", "1.0");
define("FORTIAUTHENTICATOR", ".1.3.6.1.4.1.12356.113.1");
define("facSysModel", ".1.0");
define("facSysCpuUsage", ".4.0");
define("facSysMemUsage", ".5.0");
define("facSysLogDiskUsage", ".6.0");
define("facHaCurrentStatus", ".201.1.0");
define("facAuthUserCount", ".202.1.0");
define("facAuthGroupCount", ".202.2.0");
define("facFortiTokenCount", ".202.3.0");
define("facAuthUsersRemaining", ".202.4.0");
define("facAuthGroupRemaining", ".202.5.0");
define("facFortiTokenRemaining", ".202.6.0");
define("facRadiusNasCount", ".202.7.0");
define("facRadiusNasRemaining", ".202.8.0");
define("facUserCertificateCount", ".202.9.0");
define("facRadiusLoginsTotal", ".202.10.0");
define("facRadiusLogins5Mins", ".202.11.0");
define("facRadiusFailuresTotal", ".202.12.0");
define("facRadiusFailures5Mins", ".202.13.0");
define("facRadiusAccountingTotal", ".202.14.0");
define("facRadiusAccounting5Mins", ".202.15.0");
define("facLdapLoginsTotal", ".202.16.0");
define("facLdapLogins5Mins", ".202.17.0");
define("facLdapFailuresTotal", ".202.18.0");
define("facLdapFailures5Mins", ".202.19.0");
define("facAuthEventsTotal", ".202.20.0");
define("facAuthEvents5Mins", ".202.21.0");
define("facAuthFailuresTotal", ".202.22.0");
define("facAuthFailures5Mins", ".202.23.0");
define("facRadiusProxyInTotal", ".202.24.0");
define("facRadiusProxyOutTotal", ".202.25.0");

$np = null;

function getGuideLine() {

	print "
Modes availables:

	cpu
	    Instantaneous CPU usage

	memory
	    Instantaneous memory utilization

	logdisk
	    Instantaneous log disk usage

	ha-status
	    Instantaneous HA status for this node

	users
	    Number of local users and number of local users that can still be added
		before reaching the table limit

	groups
	    Number of user groups and Number of user groups that can still be added
		before reaching the table limit

	tokens
	    Number of FortiTokens and number of FortiTokens that can still be added
		before reaching the table limit

	radius-nas
	    Number of Radius NAS and number of Radius NAS that can still be added
		before reaching the table limit

	user-certificates
	    Number of user certificates

	radius-login
	    Number of Radius logins since startup and number of Radius logins in
		the last 5 minutes

	radius-failure
	    Number of Radius login failures since startup and number of Radius login
		failures in the last 5 minutes

	radius-accounting
	    Number of Radius accounting records since startup and number of Radius
		accounting records in the last 5 minutes

	ldap-logins
	    Number of Ldap logins since startup and number of Ldap logins in the
		last 5 minutes

	ldap-failures
	    Number of Ldap login failures since startup and number of Ldap login
		failures in the last 5 minutes

	auth-events
	    Number of authentication events since startup and number of authentication
		events in the last 5 minutes

	auth-failures
	    Number of authentication failures since startup and number of authentication
		failures in the last 5 minutes

	radius-proxy
	    In Total: Number of Radius accounting proxy requests received since startup
	    Out Total: Number of Radius accounting proxy requests sent since startup

";

	exit(0);

}

function set_nagios() {

	# Constructor
	global $np;

	$np = new Nagios_Plugin(
		array (
			'version' => VERSION . " [kb.opservices.com.br]",
			'blurb' => "Developed by:\n\tOpServices\n"
            			. "Author: \nOtavio Honorio - otavio.honorio@opservices.com.br\n",
			'usage' => "Usage:\n\t%s -H <hostname> -C <communityid> -m <mode name>\n"
				. " \t -w <warning> -c <critical>"
		)
	);

	$np->add_arg("hostname|H=s", "Name of host in OpMon", 1);
	$np->add_arg("communityid|C=i", "Id of community of host in OpMon", 1);
	$np->add_arg("mode|m=s", "Please check --man for all modes", 1);
	$np->add_arg("warning|w=i", "Warning value in percentage");
	$np->add_arg("critical|c=i", "Critical value in percentage");
	$np->add_arg("man", "For a list of all modes available");


	$np->getopts();

}

function get_snmp($hostname, $comm, $oid) {

	$snmp = new SNMPIntegration( $comm, $hostname );

	$result = $snmp->walk($oid);

	if (!(sizeof($result))) {
		print "Timeout: No Response from {$hostname}\n";
		exit(3);
	}

	return $result;

}

function main() {

	global $np;

	set_nagios();

	if (isset($np->opts['man'])) getGuideLine();

	$comm = SNMPCommunity::get_community_by_id($np->opts['communityid']);

	$result = get_snmp($np->opts['hostname'], $comm, FORTIAUTHENTICATOR.facSysModel);
	$model = $result[FORTIAUTHENTICATOR.facSysModel];
	$model = str_replace('"',"",$model);

	$gauge = array(
		'cpu' => "CPU Usage",
		'memory' => "Memory Usage",
		'logdisk' => "Log Disk Usage"
	);

	$mode = $np->opts['mode'];

	if (in_array($mode,array_keys($gauge))) {

		$gauge_oid = array(
			'cpu' => FORTIAUTHENTICATOR.facSysCpuUsage,
			'memory' => FORTIAUTHENTICATOR.facSysMemUsage,
			'logdisk' => FORTIAUTHENTICATOR.facSysLogDiskUsage
		);

		$result = get_snmp($np->opts['hostname'], $comm, $gauge_oid[$mode]);

		$metric = $result[$gauge_oid[$mode]];

		$threshold = new Nagios_Plugin_Threshold($np->opts['warning'], $np->opts['critical'], 0, 100);

		$np->add_perfdata($mode, $metric, '%', $threshold);

		$np->nagios_exit(
			$np->check_threshold($metric, $np->opts['warning'], $np->opts['critical']),
			"{$model} - {$gauge[$mode]}: {$metric}%"
		);

	} elseif ($mode == "ha-status") {

		$oid = FORTIAUTHENTICATOR.facHaCurrentStatus;

		$status = array(
			1 => 'unknownOrDetermining',
			2 => 'clusterMaster',
			3 => 'clusterSlave',
			4 => 'standaloneMaster',
			5 => 'loadBalancingSlave',
			6 => 'disabled'
		);

		$result = get_snmp($np->opts['hostname'], $comm, $oid);

		$metric = $result[$oid];

		$np->nagios_exit(0, "{$model} HA Status: {$status[$metric]}");

	} elseif ($mode == "user-certificate") {

		$threshold = new Nagios_Plugin_Threshold($np->opts['warning'],$np->opts['critical'],0);

		$oid = FORTIAUTHENTICATOR.facUserCertificateCount;

		$count = get_snmp($np->opts['hostname'], $comm, $oid);

		$np->add_perfdata($mode,$count[$oid],"",$threshold);

		$np->nagios_exit(
			$np->check_threshold($count[$oid], $np->opts['warning'], $np->opts['critical']),
			"{$model} - {$mode}: {$count[$oid]}"
		);

	} elseif ($mode == "users") {

		get_count_oids_with_max(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facAuthUserCount,
							FORTIAUTHENTICATOR.facAuthUsersRemaining
		);

	} elseif ($mode == "groups") {

		get_count_oids_with_max(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facAuthGroupCount,
							FORTIAUTHENTICATOR.facAuthGroupRemaining
		);


	} elseif ( $mode == "tokens" ) {

		get_count_oids_with_max(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facFortiTokenCount,
							FORTIAUTHENTICATOR.facFortiTokenRemaining
		);

	} elseif ( $mode == "radius-nas" ) {

		get_count_oids_with_max(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facRadiusNasCount,
							FORTIAUTHENTICATOR.facRadiusNasRemaining
		);

	} elseif ( $mode == "radius-login" ) {

		get_count_over_5_min(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facRadiusLoginsTotal,
							FORTIAUTHENTICATOR.facRadiusLogins5Mins
		);

	} elseif ( $mode == "radius-failure" ) {

		get_count_over_5_min(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facRadiusFailuresTotal,
							FORTIAUTHENTICATOR.facRadiusFailures5Mins
		);

	} elseif ( $mode == "radius-accounting" ) {

		get_count_over_5_min(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facRadiusAccountingTotal,
							FORTIAUTHENTICATOR.facRadiusAccounting5Mins
		);

	} elseif ( $mode == "ldap-logins" ) {

		get_count_over_5_min(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facLdapLoginsTotal,
							FORTIAUTHENTICATOR.facLdapLogins5Mins
		);

	} elseif ( $mode == "ldap-failures" ) {

		get_count_over_5_min(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facLdapFailuresTotal,
							FORTIAUTHENTICATOR.facLdapFailures5Mins
		);

	} elseif ( $mode == "auth-events" ) {

		get_count_over_5_min(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facAuthEventsTotal,
							FORTIAUTHENTICATOR.facAuthEvents5Mins
		);

	} elseif ( $mode == "auth-failures" ) {

		get_count_over_5_min(
							$mode,
							$model,
							$comm,
							FORTIAUTHENTICATOR.facAuthFailuresTotal,
							FORTIAUTHENTICATOR.facAuthFailures5Mins
		);

	} elseif ( $mode == "user-certificates" ) {

		$oid = FORTIAUTHENTICATOR.facUserCertificateCount;

		$users = get_snmp($np->opts['hostname'], $comm, $oid);

		$threshold = new Nagios_Plugin_Threshold($np->opts['warning'],$np->opts['critical'],0);

		$np->add_perfdata($mode,$users[$oid],"",$threshold);

		$np->nagios_exit(
			$np->check_threshold($users[$oid], $np->opts['warning'], $np->opts['critical']),
			"{$model} - $mode: {$users[$oid]}"
		);

	} elseif ( $mode == "radius-proxy" ) {

		$oid_in_total  = FORTIAUTHENTICATOR.facRadiusProxyInTotal;
		$oid_out_total = FORTIAUTHENTICATOR.facRadiusProxyOutTotal;

		$in_total = get_snmp($np->opts['hostname'], $comm, $oid_in_total);
		$out_total = get_snmp($np->opts['hostname'], $comm, $oid_out_total);

		$np->add_perfdata("proxy_in_total",$in_total[$oid_in_total]);
		$np->add_perfdata("proxy_out_total",$out_total[$oid_out_total]);

		$np->nagios_exit(0,
			"{$model} - RadiusProxyInTotal: $in_total[$oid_in_total] - RadiusProxyOutTotal: $out_total[$oid_out_total]"
		);

	} else {

		print "Mode {$np->opts['mode']} not support or not found.\n";
		exit(3);

	}

}

function get_count_over_5_min ($mode,$model,$comm,$total_oid,$five_min_oid) {

	global $np;

	$threshold = new Nagios_Plugin_Threshold($np->opts['warning'],$np->opts['critical'],0);

	$five_min = get_snmp($np->opts['hostname'], $comm, $five_min_oid);
	$total = get_snmp($np->opts['hostname'], $comm, $total_oid);

	$label_five_min = $mode . "_last_five_min";
	$label_count = $mode . "_total";

	$np->add_perfdata($label_five_min,$five_min[$five_min_oid],"",$threshold);
	$np->add_perfdata($label_count,$total[$total_oid]);

	$np->nagios_exit(
		$np->check_threshold($five_min[$five_min_oid], $np->opts['warning'], $np->opts['critical']),
		"{$model} - $mode in the last five min: {$five_min[$five_min_oid]}"
	);

}

function get_count_oids_with_max ($mode,$model,$comm,$count_oid,$rem_oid) {

	global $np;

	$threshold = new Nagios_Plugin_Threshold($np->opts['warning'],$np->opts['critical'],0);

	$count = get_snmp($np->opts['hostname'], $comm, $count_oid);
	$remaining = get_snmp($np->opts['hostname'], $comm, $rem_oid);
	$max = $count[$count_oid] + $remaining[$rem_oid];

	$label_count = $mode . "_count";
	$label_rem = $mode . "_remaining";
	$label_max = "max_" . $mode;

	$np->add_perfdata($label_count,$count[$count_oid],"",$threshold);
	$np->add_perfdata($label_rem,$remaining[$rem_oid]);
 	$np->add_perfdata($label_max,$max);

	$np->nagios_exit(
		$np->check_threshold($count[$count_oid], $np->opts['warning'], $np->opts['critical']),
		"{$model} - $mode count: {$count[$count_oid]}"
	);

}

main();
